<template>
  <NoDataText v-if="!items || items.length === 0" />
  <div v-else>
    <div class="d-flex align-center justify-center mb-8">
      <v-pagination v-model="page" :length="pageCount" :total-visible="10" />
      <v-select
        v-model="countPerPage"
        label="Count Per Page"
        :items="[10, 20, 50, 100]"
        hide-details
        variant="outlined"
        density="compact"
        style="max-width: 140px"
      />
    </div>
    <template v-for="item in pageItems">
      <slot :item="item">
        <div :key="item">{{ item }}</div>
      </slot>
    </template>
    <div class="d-flex align-center justify-center mt-8">
      <v-pagination v-model="page" :length="pageCount" :total-visible="10" />
      <v-select
        v-model="countPerPage"
        label="Count Per Page"
        :items="[10, 20, 50, 100]"
        hide-details
        variant="outlined"
        density="compact"
        style="max-width: 140px"
      />
    </div>
  </div>
</template>

<script>
export default {
  props: {
    items: {
      type: Array,
      default: () => [],
    },
  },
  data: () => ({
    page: 1,
    countPerPage: 10,
  }),
  computed: {
    pageCount() {
      return Math.ceil(this.items.length / this.countPerPage);
    },
    pageItems() {
      const start = (this.page - 1) * this.countPerPage;
      return this.items.slice(start, start + this.countPerPage);
    },
  },
  watch: {
    pageCount() {
      this.page = 1;
    },
  },
};
</script>
